package svb.phone.sms;

import android.Manifest;
import android.content.BroadcastReceiver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.provider.Telephony;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.PermissionChecker;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.telephony.PhoneNumberUtils;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.lang.reflect.Method;
import java.util.Calendar;
import java.util.GregorianCalendar;

public class MainActivity extends AppCompatActivity implements View.OnClickListener{

    public static final String TAG = MainActivity.class.getName();
    public static final int PERMISSION_RESULT_CODE = 123;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        setupView();

        setDefaultApp();

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            if (checkSelfPermission(Manifest.permission.READ_SMS) != PackageManager.PERMISSION_GRANTED) {
                requestPermissions(new String[]{
                        Manifest.permission.BROADCAST_SMS,
                        Manifest.permission.READ_SMS,
                        Manifest.permission.SEND_SMS,
                        Manifest.permission.RECEIVE_SMS}, PERMISSION_RESULT_CODE);
            }
        }
    }

    private void setupView(){
        findViewById(R.id.button_draft).setOnClickListener(this);
        findViewById(R.id.button_inbox).setOnClickListener(this);
        findViewById(R.id.button_outbox).setOnClickListener(this);
        findViewById(R.id.button_sent).setOnClickListener(this);

    }

    private void setDefaultApp(){
        final String myPackageName = getPackageName();
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            if (!Telephony.Sms.getDefaultSmsPackage(this).equals(myPackageName)) {
                Intent intent =
                        new Intent(Telephony.Sms.Intents.ACTION_CHANGE_DEFAULT);
                intent.putExtra(Telephony.Sms.Intents.EXTRA_PACKAGE_NAME,
                        myPackageName);
                startActivity(intent);
            }
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        if (requestCode == PERMISSION_RESULT_CODE){
            for (int i= 0; i< permissions.length; i++) {
                Log.d(TAG, permissions[i] + " " + grantResults[i]);
            }
        }
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
    }


    @Override
    public void onClick(View v) {
        switch(v.getId()){

            case R.id.button_draft:
                ContentValues values1 = new ContentValues();
                values1.put("address", "0901123456");
                values1.put("body", "test draft");
                getContentResolver().insert(Uri.parse("content://sms/draft"), values1);
                break;
            case R.id.button_inbox:
                ContentValues values2 = new ContentValues();
                values2.put("address", "0901123456");
                values2.put("body", "test inbox");
                getContentResolver().insert(Uri.parse("content://sms/inbox"), values2);
                break;
            case R.id.button_outbox:
                ContentValues values3 = new ContentValues();
                values3.put("address", "0901123456");
                values3.put("body", "test outbox");
                getContentResolver().insert(Uri.parse("content://sms/outbox"), values3);
                break;
            case R.id.button_sent:
                ContentValues values4 = new ContentValues();
                values4.put("address", "0901123456");
                values4.put("body", "test sent");
                getContentResolver().insert(Uri.parse("content://sms/sent"), values4);
                break;

        }
    }


}
